/* $Workfile: OsaMemDbg.h $   $Revision: 6 $    $Modtime: 2/10/04 10:29a $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 1998-2003, All Rights Reserved

*******************************************************************************/

#ifndef OSA_MEM_DBG
#define OSA_MEM_DBG

#include "Api/OsaDef.h"

#if DBG

// Values which is used to fill memory that is not being used (to provoke hard-to-find errors earlier)
#define OSA_NO_MANS_LAND_VAL     0xFD   // Same value Microsoft is using
#define OSA_FREED_BLOCKS_VAL     0xDD   // Same value Microsoft is using
#define OSA_NEW_BLOCKS_VAL       0xCD   // Same value Microsoft is using
#define OSA_NO_MANS_LAND_CB      16

struct OsaMemoryHeader {
  size_t            m_cbUserBlock;
  OsaUint32         m_nSequence;
  OsaBool32         m_bDeleted;
  int               m_nLine;
  char              *m_pszFileName;
  OsaMemoryHeader   *m_pNext;
  OsaMemoryHeader   *m_pPrev;
  int               m_Pad;
};

#define OSA_EXTRA_MEM_NEEDED (sizeof(OsaMemoryHeader) + (2 * (OSA_NO_MANS_LAND_CB)))

void OsaDumpMemoryHeader(char *s, void *pUser);
OsaUint32 OsaMemoryGetCurrentUsage();
void OsaPrintCurrentlyUsed();
OsaBool32 OsaIsMemoryConstByte(void *pMemory, size_t cbMemory, OsaUint8 nConstValue);
void *OsaIsMemoryValid(void *pUser);
void *OsaMakeMemoryHeaderTail(void *pBase, size_t cbUserBlock, char *szFileName, int nLine);
void *OsaUndoMemoryHeaderTail(void *pUser);

#else   // #if DBG

#if OSA_NDIS
struct OsaMemoryHeader {
  size_t            m_cbUserBlock;
  int               m_Pad[3];
};

void *OsaMakeMemoryHeaderTail(void *pBase, size_t cbUserBlock, char *szFileName, int nLine);
void *OsaUndoMemoryHeaderTail(void *pUser);

#define OSA_EXTRA_MEM_NEEDED (sizeof(OsaMemoryHeader))

#else   // #if OSA_NDIS

// HJ990318 We must allocate one extra byte otherwise the Win98 driver will crash at bootup. I don't know exactly which piece of the code that overwrites its boundaries but I suspect OdVector
// LME990909 This is probably fixed now, I remember there was something we did that we thought could fix it, but I forget exactly what
#define OSA_EXTRA_MEM_NEEDED 4

#endif  // #if OSA_NDIS

#endif  // #if DBG

#endif  // #ifndef OSA_MEM_DBG
